'use strict';
goog.provide('Blockly.Blocks.Motor_Shield_7GP');

goog.require('Blockly.Blocks');

Blockly.Blocks.Motor_Shield_7GP.HUE3 = 140;
//
//
Blockly.Blocks.Armbot_init = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("初始化机械臂");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setTooltip('www.7gp.cn 微信公众号：奇果派工坊');
	}
};

// 直线移动
Blockly.Blocks.Armbot_GotoPoint = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		// this.appendDummyInput()
		// 	.appendField("直线移动 X:")
		// 	.appendField(new Blockly.FieldNumber('0'), 'X')
		// 	.appendField(" Y:")
		// 	.appendField(new Blockly.FieldNumber('0'), 'Y')
		// 	.appendField(" Z:")
		// 	.appendField(new Blockly.FieldNumber('0'), 'Z');
		this.appendDummyInput()
			.appendField("直线移动 X:");
		this.appendValueInput("X", Number)
			.setCheck(Number);
		this.appendDummyInput().appendField("Y:");
		this.appendValueInput("Y", Number)
			.setCheck(Number);
		this.appendDummyInput().appendField("Z:");
		this.appendValueInput("Z", Number)
			.setCheck(Number);
		this.setInputsInline(true);
		this.setPreviousStatement(true, null);
		this.setNextStatement(true, null);
		this.setTooltip('设置X,Y,Z坐标');

	}
};

//门型坐标
Blockly.Blocks.Armbot_GotoPointCylinder = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);



		// this.appendDummyInput()
		// 	.appendField("柱型移动 θ:")
		// 	.appendField(new Blockly.FieldNumber('0'), 'THETA')
		// 	.appendField(" R:")
		// 	.appendField(new Blockly.FieldNumber('0'), 'R')
		// 	.appendField(" Z:")
		// 	.appendField(new Blockly.FieldNumber('0'), 'Z');
		this.appendDummyInput()
			.appendField("柱型移动 θ:");
		this.appendValueInput("THETA", Number)
			.setCheck(Number);
		this.appendDummyInput().appendField("R:");
		this.appendValueInput("R", Number)
			.setCheck(Number);
		this.appendDummyInput().appendField("Z:");
		this.appendValueInput("Z", Number)
			.setCheck(Number);

		this.setInputsInline(true);
		this.setPreviousStatement(true, null);
		this.setNextStatement(true, null);
		this.setTooltip('设置柱形坐标');
	}
};


//钳爪操作
Blockly.Blocks.Armbot_SwicthGripper = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		var OPT = [
			["open", "open"],
			["close", "close"]
		];

		this.appendDummyInput("")
			.appendField("钳爪")
			.appendField(new Blockly.FieldDropdown(OPT), "opt");
		this.setPreviousStatement(true);
		this.setNextStatement(true);

	}
};

//增量移动
Blockly.Blocks.Armbot_MoveXYZG = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		var AXIS = [
			["X", "1"],
			["Y", "2"],
			["Z", "3"],
			["Gripper", "4"],
		];
		var N_VALUE = [
			["1", "1"],
			["-1", "-1"],
			["-2", "-2"],
			["2", "2"],
		];

		this.appendDummyInput("")
			.appendField("增量移动 坐标:")
			.appendField(new Blockly.FieldDropdown(AXIS), "axis")
			.appendField("增量为:")
			.appendField(new Blockly.FieldDropdown(N_VALUE), "value");
		this.setPreviousStatement(true);
		this.setNextStatement(true);

	}
};


Blockly.Blocks.Armbot_Stat = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("获取机械臂状态");
		this.setOutput(true, Number);
		this.setTooltip('机械臂状态 0:静止;1:录制;2:回放');
	}
};

Blockly.Blocks.Armbot_setStat = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		var STAT = [
			["IDLE", "0"],
			["RECORD", "1"],
			["REPLAY", "2"],
		];

		this.appendDummyInput("")
			.appendField("设置机械臂状态:")
			.appendField(new Blockly.FieldDropdown(STAT), "stat");
		this.setPreviousStatement(true);
		this.setNextStatement(true);

	}
};

//
Blockly.Blocks.Armbot_Record = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("记录当前坐标点");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setInputsInline(true);

	}
};

//
Blockly.Blocks.Armbot_CleanRecord = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("清空记录");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setInputsInline(true);

	}
};

//
Blockly.Blocks.Armbot_Replay = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("记录回放");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setInputsInline(true);

	}
};

//
Blockly.Blocks.JoystickB_init = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("初始化B版摇杆");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setTooltip('www.7gp.cn 奇果派工坊');

	}
};


Blockly.Blocks.JoystickB_stk = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		var PSSTK = [
			["RX", "3"],
			["RY", "2"],
			["LX", "0"],
			["LY", "1"],
		];
		this.appendDummyInput("")
			.appendField("摇杆")
			.appendField(new Blockly.FieldDropdown(PSSTK), "jbstk");

		this.setOutput(true, Number);
		var thisBlock = this;
		this.setTooltip('获取摇杆数值');

	}
};

//
Blockly.Blocks.JoystickB_Button = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		var JBBUTTON = [
			["A", "A"],
			["B", "B"],
		];
		this.appendDummyInput("")
			.appendField("按下按钮")
			.appendField(new Blockly.FieldDropdown(JBBUTTON), "jbbt");
		this.setOutput(true, Boolean);
		var thisBlock = this;
		this.setTooltip('摇杆按钮：左A，右B');

	}
};


//
Blockly.Blocks.JoystickB_LongButton = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("按钮A长按");
		this.setOutput(true, Boolean);
		var thisBlock = this;
		this.setTooltip('按钮A被长按');
	}
};

//
Blockly.Blocks.JoystickB_LED = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		var LED = [
			["OFF", "off"],
			["ON", "on"],
		];
		this.appendDummyInput("")
			.appendField("LED灯")
			.appendField(new Blockly.FieldDropdown(LED), "jbled");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setInputsInline(true);

	}
};

Blockly.Blocks.JoystickB_LEDBlink = {
	init: function () {
		this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
		this.appendDummyInput("")
			.appendField("LED灯闪烁 间隔(ms):")
			.appendField(new Blockly.FieldNumber('500'), "idle");
		this.setPreviousStatement(true);
		this.setNextStatement(true);
		this.setInputsInline(true);

	}
};