(() => {
'use strict'; 
goog.require('Blockly.Arduino');
goog.require('Mixly.Config');

function heredoc(fn) {
	return fn.toString().split('\n').slice(1, -1).join('\n') + '\n'
}

Blockly.Arduino.forBlock['Armbot_init'] = function () {
	Blockly.Arduino.definitions_['define_Servo'] = '#include <Servo.h>';
	Blockly.Arduino.definitions_['define_QGPArmbot'] = '#include <QGPArmbot.h>';
	Blockly.Arduino.definitions_['define_QGPArmbot_init'] = 'QGPArmbot qgpArm; ';

	Blockly.Arduino.setups_['setup_QGPArmbot_init_begin'] = 'qgpArm.begin(); ';
	return '';
};

Blockly.Arduino.forBlock['Armbot_GotoPoint'] = function () {
	var x = Blockly.Arduino.valueToCode(this, 'X', Blockly.Arduino.ORDER_ATOMIC);//this.getFieldValue('X');
	var y = Blockly.Arduino.valueToCode(this, 'Y', Blockly.Arduino.ORDER_ATOMIC);//this.getFieldValue('Y');
	var z = Blockly.Arduino.valueToCode(this, 'Z', Blockly.Arduino.ORDER_ATOMIC);//this.getFieldValue('Z');
	return 'qgpArm.gotoPoint(' + x + ',' + y + ',' + z + ');\n';
};

Blockly.Arduino.forBlock['Armbot_GotoPointCylinder'] = function () {
	var theta = Blockly.Arduino.valueToCode(this, 'THETA', Blockly.Arduino.ORDER_ATOMIC);// this.getFieldValue('THETA');
	var r = Blockly.Arduino.valueToCode(this, 'R', Blockly.Arduino.ORDER_ATOMIC);//this.getFieldValue('R');
	var z = Blockly.Arduino.valueToCode(this, 'Z', Blockly.Arduino.ORDER_ATOMIC);//this.getFieldValue('Z');
	return 'qgpArm.gotoPointCylinder(' + theta + ',' + r + ',' + z + ');\n';
};

Blockly.Arduino.forBlock['Armbot_SwicthGripper'] = function () {
	var opt = this.getFieldValue('opt');
	if (opt == 'open') {
		return 'qgpArm.openGripper();\n';
	} else {
		return 'qgpArm.closeGripper();\n';
	}
};

Blockly.Arduino.forBlock['Armbot_MoveXYZG'] = function () {
	var axis = this.getFieldValue('axis');
	var value = this.getFieldValue('value');
	return 'qgpArm.moveXYZG(' + axis + ',' + value + ');\n';
};

Blockly.Arduino.forBlock['Armbot_Stat'] = function () {
	var st = "qgpArm.getArmMode()";
	return [st,Blockly.Arduino.ORDER_ATOMIC];
}

Blockly.Arduino.forBlock['Armbot_setStat'] = function () {
	var stat = this.getFieldValue('stat');
	return 'qgpArm.setArmMode(' + stat  + ');\n';
};


Blockly.Arduino.forBlock['Armbot_Record'] = function () {
	return 'qgpArm.record();\n';
};

Blockly.Arduino.forBlock['Armbot_CleanRecord'] = function () {
	return 'qgpArm.cleanRecord();\n';
};

Blockly.Arduino.forBlock['Armbot_Replay'] = function () {
	return 'qgpArm.replay();\n';
};

Blockly.Arduino.forBlock['JoystickB_init'] = function () {
	//	var board = this.getFieldValue('board');	
	//	Blockly.Arduino.definitions_['define_SPI'] = board;
	Blockly.Arduino.definitions_['define_QGPJoystickB'] = '#include <QGPJoystickB.h>';
	Blockly.Arduino.definitions_['define_QGPJoystickB_init'] = 'QGPJoystickB joystickB;';
	Blockly.Arduino.setups_['setup_PS2X_init'] = 'joystickB.begin();';
	return '';
};

Blockly.Arduino.forBlock['JoystickB_stk'] = function () {
	var stk = this.getFieldValue('jbstk');
	var st = "joystickB.Analog(" + stk + ")";
	return [st,Blockly.Arduino.ORDER_ATOMIC];
};


//readcardnum
Blockly.Arduino.forBlock['JoystickB_Button'] = function () {
	var bt = this.getFieldValue('jbbt');
	if (bt == "A") {
		var st = "joystickB.ButtonPressed(2)";
	} else {
		var st = "joystickB.ButtonPressed(4)";
	}
	return [st,Blockly.Arduino.ORDER_ATOMIC];
};

Blockly.Arduino.forBlock['JoystickB_LongButton'] = function () {
	var st= 'joystickB.ButtonALongPressed()';
	return [st,Blockly.Arduino.ORDER_ATOMIC];
};


Blockly.Arduino.forBlock['JoystickB_LED'] = function () {
	var jbled = this.getFieldValue('jbled');
	if(jbled=='on'){
		return 'joystickB.ledOn();\n';
	}else{
		return 'joystickB.ledOff();\n';
	}
};

Blockly.Arduino.forBlock['JoystickB_LEDBlink'] = function () {
	var jbidle = this.getFieldValue('idle');
	return 'joystickB.ledBlink('+jbidle+');\n';
};

})();