#include "QGPJoystickB.h"

uint16_t key_cnt;
uint8_t keyStat;
boolean isLEDBlink = false;
unsigned long ledIDLE = 500;
unsigned long previousMillis = 0;
int ledState = LOW;
void _blink()
{
    unsigned long currentMillis = millis();
    if (currentMillis - previousMillis >= ledIDLE)
    {
        // save the last time you blinked the LED
        previousMillis = currentMillis;
        // if the LED is off turn it on and vice-versa:
        if (!isLEDBlink)
            return;
        if (ledState == LOW)
        {
            ledState = HIGH;
        }
        else
        {
            ledState = LOW;
        }
        digitalWrite(LED_PIN, ledState);
    }
}

void TimerCBK(void)
{
    cli();
    if (digitalRead(BT_A) == LOW)
    {
        key_cnt++;
        if (QGP_armMode == ARM_MODE_REPLAY)
        {
            QGP_armMode = ARM_MODE_IDLE;
            isLEDBlink=false;
            digitalWrite(LED_PIN, HIGH);
        }
    }
    else
    {
        key_cnt = 0;
    }
    if (isLEDBlink)
    {
        _blink();
    }
    sei();
}

void QGPJoystickB::begin()
{
    pinMode(BT_A, INPUT_PULLUP);
    pinMode(BT_B, INPUT_PULLUP);
    pinMode(LED_PIN, OUTPUT);
    digitalWrite(LED_PIN, HIGH);
    key_cnt = 0;
    keyStat = 0;
    isLEDBlink = false;
    MsTimer2::set(10, TimerCBK); // 10ms调用一次TimerCBK函数
    MsTimer2::start();
}


int QGPJoystickB::Analog(int _axis)
{
    int val = analogRead(_axis);
    val = map(val, 0, 1023, 0, 255);
    return val;
}

boolean QGPJoystickB::ButtonALongPressed()
{
    return key_cnt > TIME_2S ? true : false;
}

boolean QGPJoystickB::ButtonPressed(unsigned int btx)
{
    return digitalRead(btx) == 0 ? true : false;
}

void QGPJoystickB::ledOff()
{
    cli();
    isLEDBlink = false;
    digitalWrite(LED_PIN, LOW);
    sei();
}

void QGPJoystickB::ledOn()
{
    cli();
    isLEDBlink = false;
    digitalWrite(LED_PIN, HIGH);
    sei();
}

void QGPJoystickB::ledBlink(int _idle)
{
    cli();
    ledIDLE = _idle;
    isLEDBlink = true;
    sei();
}
